import mcrfpy
font = mcrfpy.Font("assets/JetbrainsMono.ttf")
texture = mcrfpy.Texture("assets/kenney_tinydungeon.png", 16, 16)

print("[game.py] Default texture:")
print(mcrfpy.default_texture)
print(type(mcrfpy.default_texture))

# build test widgets

mcrfpy.createScene("pytest")
mcrfpy.setScene("pytest")
ui = mcrfpy.sceneUI("pytest")

# Frame
f = mcrfpy.Frame(25, 19, 462, 346, fill_color=(255, 92, 92))
print("Frame alive")
# fill (LinkedColor / Color):    f.fill_color
# outline (LinkedColor / Color): f.outline_color
# pos (LinkedVector / Vector):   f.pos
# size (LinkedVector / Vector):  f.size

# Caption
print("Caption attempt w/ fill_color:")
#c = mcrfpy.Caption(512+25, 19, "Hi.", font)
#c = mcrfpy.Caption(512+25, 19, "Hi.", font, fill_color=(255, 128, 128))
c = mcrfpy.Caption(512+25, 19, "Hi.", font, fill_color=mcrfpy.Color(255, 128, 128), outline_color=(128, 255, 128))
print("Caption alive")
# fill (LinkedColor / Color):    c.fill_color
#color_val = c.fill_color
print(c.fill_color)
#print("Set a fill color")
#c.fill_color = (255, 255, 255)
print("Lol, did it segfault?")
# outline (LinkedColor / Color): c.outline_color
# font (Font):                   c.font
# pos (LinkedVector / Vector):   c.pos

# Sprite
s = mcrfpy.Sprite(25, 384+19, texture, 86, 9.0)
# pos (LinkedVector / Vector):   s.pos
# texture (Texture):             s.texture
s.click = lambda *args, **kwargs: print("clicky", args, kwargs)

# Grid
g = mcrfpy.Grid(10, 10, texture, 512+25, 384+19, 462, 346)
# texture (Texture):             g.texture
# pos (LinkedVector / Vector):   g.pos
# size (LinkedVector / Vector):  g.size

for _x in range(10):
    for _y in range(10):
        g.at((_x, _y)).color = (255 - _x*25, 255 - _y*25, 255)
g.zoom = 2.0

[ui.append(d) for d in (f, c, s, g)]

# Entity
e = mcrfpy.Entity(5, 5, mcrfpy.default_texture, 86)
e.pos = e.draw_pos # TODO - sync draw/collision positions on init
g.entities.append(e)
import random
def wander(*args, **kwargs):
    p = e.pos
    new_p = (p[0] + random.randint(-1, 1), p[1] + random.randint(-1, 1))
    if g.grid_size[0] >= new_p[0] >= 0 and g.grid_size[1] >= new_p[1] >= 0:
        e.pos = new_p
    #print(e.pos)

mcrfpy.setTimer("wander", wander, 400)

last_anim = None
def anim(t, *args, **kwargs):
    global last_anim
    if last_anim is None:
        last_anim = t
        return
    duration = t - last_anim

    entity_speed = 1 / 250 # 250 milliseconds to move one square
    if e.pos == e.draw_pos:
        return
    tx, ty = e.pos #"target" position - entity is already occupying that spot, animate them moving there.
    dx, dy = e.draw_pos #"draw" position
    newx = tx if (abs(dx - tx) < entity_speed * duration) else entity_speed * duration
    if tx < dx: newx *= -1
    newy = ty if (abs(dy - ty) < entity_speed * duration) else entity_speed * duration
    if ty < dy: newx *= -1

    print(f"({dx}, {dy}) -> ({tx}, {ty}) = ({newx}, {newy}) ; @{entity_speed} * {duration} = {entity_speed * duration}")
    e.draw_pos = (newx, newy)

mcrfpy.setTimer("anim", anim, 67)

print("built!")

# tests

